int send_file(char *filename, unsigned server, unsigned channel)
{
  FILE *fp;
  int s;
  struct sockaddr_in server_address;
  unsigned l = sizeof(struct sockaddr_in);
  char buff[512];
  unsigned long filelen;
  unsigned rc;
  unsigned sc;
  unsigned offset;

  fp = fopen(filename, "rb");
  if(!fp)
    return 1;

  s = socket(AF_INET, SOCK_STREAM, 0);
  if(s == -1)
  {
    socket_error:
    fclose(fp);
    return 2;
  }

  getpeername(servers[server].socket, (struct sockaddr*)&server_address, &l);
  server_address.sin_port = htons(servers[server].http_port);

  if(connect(s, (struct sockaddr*)&server_address, sizeof(server_address)) == -1)
    goto socket_error;

  fseek(fp, 0, SEEK_END);
  filelen = ftell(fp);
  rewind(fp);

  // send headers
  sprintf(buff, "\
PUT %s HTTP/1.1\r\n\
Content-length: %u\r\n\
Upload-token: %.32s\r\n\r\n", filename, filelen, servers[server].upload_token);
  write(s, buff, strlen(buff));
puts(buff);

  // send the rest of the file
  while(rc = fread(buff, 1, sizeof(buff), fp))
  {
    offset = 0;
    while((offset += sc = write(s, &buff[offset], rc)) != rc)
    {
      if(sc == -1) goto end;
      rc -= sc;
    }
  }

  end:
  close(s);
  fclose(fp);
  return 0;
}

void upload_to_server(char *filename, unsigned server, unsigned channel)
{
  char command[MSGLEN+1];
  unsigned n;

  sprintf(command, "UPLOAD %s\r\n", servers[server].channels[channel].name);
  send_raw_command(command, strlen(command));

  sprintf(command, "Sending file %s to channel %s\n", filename, servers[server].channels[channel].name);
  push_channel_message(server, command, strlen(command), channel);

  for(n=10;!servers[server].upload_token[0] && --n;)
    sleep(1);

  if(!servers[server].upload_token[0])
  {
    strcpy(command, "Timeout!\n");
    push_channel_message(server, command, strlen(command), channel);
    return;
  }

  n = send_file(filename, server, channel);
  if(n == 1)
    strcpy(command, "Error while opening file\n");
  else if(n == 2)
    strcpy(command, "Error while uploading file\n");
  else
    strcpy(command, "Upload complete\n");

  push_channel_message(server, command, strlen(command), channel);

  memset(servers[server].upload_token, 0, 32);
}

void upload_file(void)
{
  GtkFileChooserNative *dialog;
  GtkFileChooserAction action = GTK_FILE_CHOOSER_ACTION_OPEN;
  gint res;
  char *filename;
  GtkFileChooser *chooser;
  unsigned server = active_server;
  unsigned channel = servers[server].active_channel;

  if(servers[active_server].active_channel < 0) return;

  dialog = gtk_file_chooser_native_new("Select file", GTK_WINDOW(window), action, "_Open", "_Cancel");
  res = gtk_native_dialog_run(GTK_NATIVE_DIALOG(dialog));

  if(res == GTK_RESPONSE_ACCEPT)
  {
    chooser = GTK_FILE_CHOOSER(dialog);
    filename = gtk_file_chooser_get_filename(chooser);

    upload_to_server(filename, server, channel);

    g_free(filename);
  }

  g_object_unref(dialog);
}
