struct hostent *resolve_dns(const char *dns)
{
  return gethostbyname(dns);
}


/*
  Returns socket descriptor
*/
int connect_host(char *address, unsigned port)
{
  int socket_desc = socket(AF_INET, SOCK_STREAM, 0);
  struct hostent *he;
  struct sockaddr_in server;
  char *ip_address;

  if(socket_desc == -1)
    return -1;

  he = resolve_dns(address);
  if(!he)
    return -2;

  ip_address = inet_ntoa(*((struct in_addr**)he->h_addr_list)[0]);
  server.sin_addr.s_addr = inet_addr(ip_address);
  server.sin_family = AF_INET;
  server.sin_port = htons(port);

  if(connect(socket_desc, (struct sockaddr*)&server, sizeof(server)) == -1)
    return -3;

  return socket_desc;
}


void *connection_handler(void *args)
{
  unsigned connection = (unsigned)(unsigned long)args;
  int bc;
  char buff[INBUFF_SIZE+1];
  char *command_start;
  char *command_end;
  unsigned command_len;
  unsigned n = 0;
  unsigned e;
  char command[MSGLEN];
  char *ptr;
/*  sigset_t sigset;

  sigemptyset(&sigset);
  sigaddset(&sigset, SIGUSR1);
  if(pthread_sigmask(SIG_BLOCK, &sigset, 0))
    puts("Error while setting a signal mask!");*/

/*  while((bc = recv(servers[connection].socket, buff, INBUFF_SIZE, 0)) >= 0)
  {
    for(ptr=buff; ptr < buff+bc;)
    {
      command[n] = *ptr++;
      if(command[n] == 0x0A)
      {
        printf("Got %u bytes long message\n", n);
        command_handler(command, n, connection);
        n = 0;
      }
      else n++;
    }
  }*/

  // optimized version
  while((bc = recv(servers[connection].socket, buff, INBUFF_SIZE, 0)) >= 0)
  {
    buff[bc] = 0;
    command_start = buff;
    while(command_end = strchr(command_start, 0x0A))
    {
      command_len = command_end - command_start + 1;
      memcpy(&command[n], command_start, command_len);
      printf("Got %u bytes long message\n", command_len);
      for(e=0;e<command_len;e++)
        putchar(command[e]);
      command_handler(command, command_len, connection);
      command_start = command_end + 1;
      n = 0;
    }
    if(bc > (command_len = command_start-buff))
    {
      memcpy(&command[n], command_start, command_len);
      n += command_len;
    }
  }
  printf("Socket: %s\n", strerror(errno));
}
