struct message
{
  char *text;
  unsigned len;
};

struct channel_messages
{
  GtkTextBuffer *messages;
  GtkTextMark *mark;
  struct message *line_queue;
  unsigned line_queue_len;
};

struct channel
{
  char name[CHANLEN];
  unsigned user_count;
  char **users;
  GtkWidget *label;
  unsigned user_list_ready:1;
  struct channel_messages messages;
  char topic[TOPICLEN];
};

struct query
{
  char nick[NICKLEN];
  struct channel_messages messages;
  GtkWidget *label;
};

struct connection
{
  char server_name[36];
  int socket;
  struct channel *channels;
  unsigned channel_count;
  struct query *queries;
  unsigned query_count;
  int active_channel;
  pthread_t connection_handler;
  struct channel_messages messages;
  char nick[NICKLEN];
  unsigned registered:1;
  unsigned has_tab:1;
  unsigned joining_p2p_voice:1;
  unsigned joining_server_voice:1;
  GtkWidget *label;
  struct sockaddr_in voice_socket_remote;
  struct sockaddr_in voice_socket_local;
  int voice_socket;
  int voice_send_socket;
  pthread_t voice_recv_thread;
  pthread_t voice_send_thread;
  volatile unsigned rec_dev;
  volatile unsigned play_dev;
  unsigned char *mix_buffer;
  unsigned char *input_buffer;
  unsigned char *raw_pcm;
  OpusEncoder *opus_encoder;
  OpusDecoder *opus_decoder;
  struct audio_buffer input_buff;
  struct audio_buffer output_buff;
  unsigned http_port;
  char upload_token[32];
};

struct voip_udp_target
{
  struct sockaddr_in addr_struct;
  char nick[NICKLEN];
};
