void *setting_options[][2] =
{
  { "Open settings", open_settings_window },
  { "Sound capture device", command_capturedev },
  { "Sound playback device", command_playbackdev },
  { "Save settings", save_settings },
  { 0, 0 }
};

void *command_center_tabs[][2] =
{
  { "Servers", setting_options },
  { "Settings", setting_options }
};

void select_option(unsigned option)
{
  if(setting_options[option][1])
    ((void(*)())setting_options[option][1])();
}

void bold_name(const char *name)
{
  unsigned n = 0;
  GtkListBoxRow *list_row;
  char *rnick;
  GtkWidget *label;

  if(!name || active_server < 0 || (!servers[active_server].joining_server_voice && !servers[active_server].joining_p2p_voice))
    return;

  while(list_row = gtk_list_box_get_row_at_index((GtkListBox*)nick_list, n++))
  {
    rnick = (char*)gtk_label_get_text((GtkLabel*)(label = (GtkWidget*)gtk_bin_get_child((GtkBin*)list_row)));
    if(*rnick == '@' || *rnick == '+') rnick++;
    if(!strcmp(rnick, name))
    {
      gtk_label_set_attributes((GtkLabel*)label, bld_attrlist);
      break;
    }
  }
}

void hide_endcall_button(void)
{
  gtk_widget_hide((GtkWidget*)endcall_button);
}

void show_endcall_button(void)
{
  gtk_widget_show((GtkWidget*)endcall_button);
}

void show_topic(const char *topic)
{
  gtk_label_set_text((GtkLabel*)topicline, topic);
}

void list_options(void *options[][2])
{
  unsigned n;
  void *label;

  for(n=0;options[n][0];n++)
  {
    label = gtk_label_new(options[n][0]);
    gtk_label_set_xalign((GtkLabel*)label, 0);
    gtk_label_set_attributes(GTK_LABEL(label), ms_attrlist);
    gtk_list_box_insert((GtkListBox*)nick_list, label, -1);
  }

  gtk_widget_show_all(nick_list);
}

void list_settings(void)
{
  unsigned n;
  void *label;

  for(n=0;n<sizeof(command_center_tabs)/sizeof(void*[2]);n++)
  {
    label = gtk_label_new(command_center_tabs[n][0]);
    gtk_label_set_xalign((GtkLabel*)label, 0);
    gtk_label_set_attributes(GTK_LABEL(label), ms_attrlist);
    gtk_list_box_insert((GtkListBox*)channel_list, label, -1);
  }

  gtk_widget_show_all(channel_list);

  show_topic("This screen contains application settings.");
}

char *server_commands[][3] =
{
  { "Join channel", "/join ", "/join [channel]: joins a channel. Text channels begin with #, voice channels begin with ! and video channels begin with ?.\n" },
  { "Part channel", "/part ", "/part [channel]: Leaves a channel.\n" },
  { "Change nick", "/nick ", "/nick [name]: Sets nickname.\n" },
  { "Voice call", "/scall ", "/scall [channel]: VoIP call to the channel using the server as a relay.\n" },
  { "P2P call", "/pcall ", "/pcall [channel]: Peer-to-peer VoIP call. Has very low latency, but does not work with all carrier-grade NATs.\n" }
};

void list_server_commands(void)
{
  unsigned n;
  void *label;

  for(n=0;n<sizeof(server_commands)/sizeof(char*[3]);n++)
  {
    label = gtk_label_new(server_commands[n][0]);
    gtk_label_set_xalign((GtkLabel*)label, 1);
    gtk_label_set_attributes(GTK_LABEL(label), ms_attrlist);
    gtk_list_box_insert((GtkListBox*)nick_list, label, -1);
  }

  show_topic("This screen contains client-to-server-commands and responses from the server.");
}
