/*
  Returns server ID, or -1 if a struct for the new server could not be allocated
*/
int new_server(void)
{
  void *new_ptr;

  if(!server_count)
  {
    servers = malloc(++server_count * sizeof(struct connection));
    if(!servers)
    {
      nomemory:
      server_count--;
      return -1;
    }
  }
  else
  {
    new_ptr = realloc(servers, ++server_count * sizeof(struct connection));
    if(!new_ptr) goto nomemory;
    servers = new_ptr;
  }
  memset(&servers[server_count-1], 0, sizeof(struct connection));

  return server_count-1;
}

void delete_server(unsigned server)
{
  server_count--;
  while(server < server_count)
  {
    servers[server] = servers[server+1];
    server++;
  }
  servers = realloc(servers, server_count * sizeof(struct connection));
}

int new_connection(char *dns, unsigned port)
{
  int sock_fd = connect_host(dns, port);
  int server_id = new_server();

  if(sock_fd == -1 || server_id == -1)
    return -1;

  servers[server_id].socket = sock_fd;

  strcpy(servers[server_id].server_name, dns);

  servers[server_id].active_channel = -1;

  pthread_create(&servers[server_id].connection_handler, 0, connection_handler, (void*)(unsigned long)server_id);

  update_ui();

  return server_id;
}
