void *settingstr[][2] =
{
  { "recording-device", &recording_device },
  { "playback-device", &playback_device },
  { "min-input-volume", &min_input_volume }
};

void load_settings(void)
{
  FILE *fp = fopen("setup.ini", "r");
  char buff[100];
  unsigned n;
  unsigned *ptr;

  if(!fp)
  {
    puts("Error opening configuration file");
    return;
  }

  puts("Loading settings...");

  while(fgets(buff, 100, fp))
  {
    for(n=sizeof(settingstr)/sizeof(char*[2]);n--;)
      if(!strncmp(settingstr[n][0], buff, strlen(settingstr[n][0])))
      {
        ptr = (unsigned*)settingstr[n][1];
        *ptr = strtoul(buff+strlen(settingstr[n][0])+1, 0, 10);
        printf("%s: %u\n", settingstr[n][0], *ptr);
        break;
      }
  }

  fclose(fp);
}

void save_settings(void)
{
  FILE *fp = fopen("setup.ini", "w");
  unsigned n = sizeof(settingstr)/sizeof(char*[2]);
  unsigned set;
  char message[] = "Settings saved.\n";

  if(!fp)
  {
    puts("Error opening configuration file");
    return;
  }

  puts("Saving settings...");

  while(n--)
  {
    fputs(settingstr[n][0], fp);
    fputc(' ', fp);
    set = *(unsigned*)settingstr[n][1];
    fprintf(fp, "%u\n", set);
  }

  fclose(fp);

  push_channel_message(-1, message, strlen(message), -1);
}

void show_audio_devices(unsigned input)
{
  int dev_cnt;
  char **list = list_audio_devices(&dev_cnt, input);
  char nodevices[] = "No audio devices found.\n";
  unsigned n;
  char message[120];
  char recording[] = "Recording devices:\n";
  char playback[] = "Playback devices:\n";
  char givecmd[] = "Append device number to command.\n";

  if(input)
    push_channel_message(-1, recording, strlen(recording), -1);
  else
    push_channel_message(-1, playback, strlen(playback), -1);

  if(list)
  {
    for(n=0;n < dev_cnt;n++)
    {
      sprintf(message, "Device [%i]: %s\n", n, list[n]);
      push_channel_message(-1, message, strlen(message), -1);
    }
    push_channel_message(-1, givecmd, strlen(givecmd), -1);
  }
  else
    push_channel_message(-1, nodevices, strlen(nodevices), -1);

  free_audio_device_list(list, dev_cnt);
}

void command_capturedev(void)
{
  show_audio_devices(1);
  set_user_message("/recdev ");
}

void command_playbackdev(void)
{
  show_audio_devices(0);
  set_user_message("/playdev ");
}

char audio_device_set[] = "Audio device set.\n";
char audio_device_outofrange[] = "Device number too large.\n";

void set_rec_device(const char *device)
{
  unsigned num = strtoul(device, 0, 10);
  if(num < audio_device_count(1))
  {
    recording_device = num;
    push_channel_message(-1, audio_device_set, strlen(audio_device_set), -1);
  }
  else
    push_channel_message(-1, audio_device_outofrange, strlen(audio_device_outofrange), -1);

}

void set_play_device(const char *device)
{
  unsigned num = strtoul(device, 0, 10);
  if(num < audio_device_count(0))
  {
    playback_device = num;
    push_channel_message(-1, audio_device_set, strlen(audio_device_set), -1);
  }
  else
    push_channel_message(-1, audio_device_outofrange, strlen(audio_device_outofrange), -1);

}
