int add_querytab(unsigned server, const char *nick, char *message)
{
  void *new_pointer;
  unsigned query_index = servers[server].query_count;
  GtkTextIter iter;

  if(!servers[server].query_count)
  {
    if(!(servers[server].queries = malloc(++servers[server].query_count* sizeof(struct query))))
    {
      nomemory:
      servers[server].query_count--;
      return -1;
    }
  }
  else
  {
    if(new_pointer = realloc(servers[server].queries, ++servers[server].query_count * sizeof(struct query)))
      servers[server].queries = new_pointer;
    else
      goto nomemory;
  }

  memset(&servers[server].queries[query_index], 0, sizeof(struct query));
  strcpy(servers[server].queries[query_index].nick, nick);

  servers[server].queries[query_index].messages.messages = gtk_text_buffer_new(0);
  gtk_text_buffer_create_tag(servers[server].queries[query_index].messages.messages, "monospace", "family", "Mono", 0);
  gtk_text_buffer_get_start_iter(servers[server].queries[query_index].messages.messages, &iter);
  servers[server].queries[query_index].messages.mark = gtk_text_buffer_create_mark(servers[server].queries[query_index].messages.messages, 0, &iter, 0);

  if(message)
    push_channel_message(server, message, strlen(message), servers[server].channel_count + query_index);

  update_ui();

  return query_index;
}

void close_querytab(unsigned server, const char *nick)
{
  int n = find_server_query(server, nick);

  if(n < 0) return;

  if(servers[server].active_channel == servers[server].channel_count+n) servers[server].active_channel--;

  servers[server].query_count--;

  while(n < servers[server].query_count)
  {
    servers[server].queries[n] = servers[server].queries[n+1];
    n++;
  }
  if(servers[server].query_count)
    servers[server].queries = realloc(servers[server].queries, servers[server].query_count * sizeof(struct query));
  else
    free(servers[server].queries);

  empty_channel_list();
  update_ui();
}

void join_channel(const char *channel, unsigned len)
{
  char cmd[100] = "JOIN ";

  strcat(cmd, channel);

  send_raw_command(cmd, len+5);
}

void delete_channel(unsigned server, const char *channel)
{
  int chan_id = find_channel_by_name(server, channel);

  if(chan_id < 0) return;

  if(servers[server].active_channel == chan_id) servers[server].active_channel--;

  servers[server].channel_count--;

  while(chan_id < servers[server].channel_count)
  {
    servers[server].channels[chan_id] = servers[server].channels[chan_id+1];
    chan_id++;
  }
  if(servers[server].channel_count)
    servers[server].channels = realloc(servers[server].channels, servers[server].channel_count * sizeof(struct channel));
  else
    free(servers[server].channels);
}

void part_channel(const char *channel, unsigned len)
{
  char cmd[100] = "PART ";

  if(active_server < 0) return;

  strcat(cmd, channel);
  send_raw_command(cmd, len+5);

  delete_channel(active_server, channel);
  empty_channel_list();
  update_ui();
}

void window_close(unsigned server)
{
  if(servers[server].active_channel < 0)
    ; // disconnect?
  else if(servers[server].active_channel < servers[server].channel_count)
    part_channel(servers[server].channels[servers[server].active_channel].name, strlen(servers[server].channels[servers[server].active_channel].name));
  else
    close_querytab(server, servers[server].queries[servers[server].active_channel - servers[server].channel_count].nick);
}

void voice_call(const char *dst, unsigned len, unsigned p2p)
{
  char cmd[100] = "PCALL ";
  int server = server_count;

  while(server--)
  {
    if(servers[server].voice_socket)
      break;
  }
  if(server >= 0) return;

  if(!p2p)
  {
    cmd[0] = 'S';
    servers[active_server].joining_server_voice = 1;
  }
  else
    servers[active_server].joining_p2p_voice = 1;

  printf("Calling to %s\n", dst);

//  show_endcall_button();

  strcat(cmd, dst);
  send_raw_command(cmd, len+5);
}

void hangup(void)
{
  int server = server_count;
  char cmd[] = "HANGUP\r\n";

  while(server--)
  {
    if(servers[server].voice_socket)
      break;
  }
  if(server < 0) return;

  printf("Ending voice call on server %i\n", server);

  if(send(servers[server].socket, cmd, strlen(cmd), 0) <= 0)
    puts("Error");

  free(voip_targets);
  voip_targets = 0;
  voip_target_count = 0;

  pthread_mutex_lock(&lock);
  // terminate VoIP threads...
  pthread_cancel(servers[server].voice_recv_thread);
  pthread_cancel(servers[server].voice_send_thread);
  // close sockets
  close(servers[server].voice_socket);
  servers[server].voice_socket = 0;
//  if(servers[server].joining_p2p_voice)
//    close(servers[server].voice_send_socket);
  pthread_mutex_unlock(&lock);

  servers[server].joining_p2p_voice = 0;
  servers[server].joining_server_voice = 0;

  hide_endcall_button();
}

void set_nick(const char *nick)
{
  char cmd[100] = "NICK ";

  printf("Set nick to %s\n", nick);

  strcat(cmd, nick);
  send_raw_command(cmd, strlen(nick)+5);
  strcpy(servers[active_server].nick, nick);
}

void register_user(const char *nick)
{
  char cmd[100] = "USER";

  sprintf(cmd, "%s %s ! %s : %s", cmd, nick, nick, nick);
  send_raw_command(cmd, strlen(cmd));
}

int add_channel(unsigned server, char *channel)
{
  void *ptr;
  unsigned len = strnllen(channel);

  if(!servers[server].channel_count)
  {
    servers[server].channels = malloc(++servers[server].channel_count * sizeof(struct channel));
    if(!servers[server].channels)
    {
      nomemory:
      servers[server].channel_count--;
      return -1;
    }
  }
  else
  {
    ptr = realloc(servers[server].channels, ++servers[server].channel_count * sizeof(struct channel));
    if(!ptr) goto nomemory;
    servers[server].channels = ptr;
  }
  memset(&servers[server].channels[servers[server].channel_count-1], 0, sizeof(struct channel));
  channel[len] = 0;
  strcpy(servers[server].channels[servers[server].channel_count-1].name, channel);

  update_ui();
}
